Debian Bug report logs - #660324
picolisp FTBFS on armhf

version graph

Package: picolisp; Maintainer for picolisp is Kan-Ru Chen (陳侃如) <koster@debian.org>; Source for picolisp is src:picolisp.

Reported by: peter green <plugwash@p10link.net>

Date: Sat, 18 Feb 2012 10:19:36 UTC

Severity: important

Tags: patch

Found in version picolisp/3.0.9.3-1

Fixed in version picolisp/3.0.9.4-1

Done: Kan-Ru Chen <koster@debian.org>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Kan-Ru Chen <koster@debian.org>:
Bug#660324; Package picolisp. (Sat, 18 Feb 2012 10:19:39 GMT) Full text and rfc822 format available.

Acknowledgement sent to peter green <plugwash@p10link.net>:
New Bug report received and forwarded. Copy sent to Kan-Ru Chen <koster@debian.org>. (Sat, 18 Feb 2012 10:19:43 GMT) Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: peter green <plugwash@p10link.net>
To: Debian Bug Tracking System <submit@bugs.debian.org>
Subject: picolisp FTBFS on armhf
Date: Sat, 18 Feb 2012 10:17:53 +0000
[Message part 1 (text/plain, inline)]
Package: picolisp
Version: 3.0.9.3-1
severity: important
tags: patch

Picolisp FTBFS on armhf with a PIE related error.  The attatched patch 
disables use of PIE on armhf to make the package build (it is already 
disabled on amd64)
[picolisp.diff (text/x-diff, attachment)]

Information forwarded to debian-bugs-dist@lists.debian.org, Kan-Ru Chen <koster@debian.org>:
Bug#660324; Package picolisp. (Mon, 05 Mar 2012 03:39:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <zumbi@debian.org>:
Extra info received and forwarded to list. Copy sent to Kan-Ru Chen <koster@debian.org>. (Mon, 05 Mar 2012 03:39:03 GMT) Full text and rfc822 format available.

Message #10 received at 660324@bugs.debian.org (full text, mbox):

From: Hector Oron <zumbi@debian.org>
To: peter green <plugwash@p10link.net>, 660324@bugs.debian.org
Subject: Re: Bug#660324: picolisp FTBFS on armhf
Date: Mon, 5 Mar 2012 04:37:51 +0100
Hello,

On Sat, Feb 18, 2012 at 10:17:53AM +0000, peter green wrote:
> Package: picolisp
> Version: 3.0.9.3-1
> severity: important
> tags: patch
> 
> Picolisp FTBFS on armhf with a PIE related error.  The attatched
> patch disables use of PIE on armhf to make the package build (it is
> already disabled on amd64)

As I see it there are two problems in the package:

1. Hardening rules are not properly passed to the build system, for that you
might need to set CFLAGS and LDFLAGS as:
  make -C src CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate
  make -C src64 CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" OS=Linux

  This way the build system takes the flags, but FTBFS, with full hardening set.


2. amd64 and armhf arches fail because the linkage is trying to link non-PIE object code.

The following patch should fix the issue with -fPIE, but you are still not passing hardening flags to the build.
I have not been able to test on armhf, but once I do, and if you dont have inconvenient I shall proceed with a NMU.

diff -Naur picolisp-3.0.9.3/debian/rules picolisp-3.0.9.3.x/debian/rules
--- picolisp-3.0.9.3/debian/rules       2012-02-17 15:19:30.000000000 +0000
+++ picolisp-3.0.9.3.x/debian/rules     2012-03-05 03:34:42.000000000 +0000
@@ -5,11 +5,6 @@
 DEB_HOST_ARCH_CPU := $(shell dpkg-architecture -qDEB_HOST_ARCH_CPU)
 DEB_HOST_ARCH_OS  := $(shell dpkg-architecture -qDEB_HOST_ARCH_OS)
   
-ifeq (amd64,$(DEB_HOST_ARCH_CPU))
-  # disabled on amd64
-  DEB_BUILD_HARDENING_PIE := 0
-endif
-
 include /usr/share/hardening-includes/hardening.make
 export CFLAGS=$(shell dpkg-buildflags --get CFLAGS)
 export LDFLAGS=$(shell dpkg-buildflags --get LDFLAGS)
diff -Naur picolisp-3.0.9.3/src/Makefile picolisp-3.0.9.3.x/src/Makefile
--- picolisp-3.0.9.3/src/Makefile       2012-03-05 03:29:47.000000000 +0000
+++ picolisp-3.0.9.3.x/src/Makefile     2012-03-05 03:28:25.000000000 +0000
@@ -13,7 +13,7 @@
        -W -Wimplicit -Wreturn-type -Wunused -Wformat \
        -Wuninitialized -Wstrict-prototypes \
        -D_GNU_SOURCE  -D_FILE_OFFSET_BITS=64
-
+CFLAGS += -fPIE
 
 OS ?=
 LDFLAGS ?=
diff -Naur picolisp-3.0.9.3/src64/Makefile picolisp-3.0.9.3.x/src64/Makefile
--- picolisp-3.0.9.3/src64/Makefile     2012-03-05 03:29:47.000000000 +0000
+++ picolisp-3.0.9.3.x/src64/Makefile   2012-03-05 03:28:45.000000000 +0000
@@ -24,6 +24,7 @@
        endif
 endif
 
+CFLAGS += -fPIE
 OS ?=
 LDFLAGS ?=
   

Regards,
-- 
  Hector Oron




Information forwarded to debian-bugs-dist@lists.debian.org, Kan-Ru Chen <koster@debian.org>:
Bug#660324; Package picolisp. (Mon, 05 Mar 2012 03:57:09 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <zumbi@debian.org>:
Extra info received and forwarded to list. Copy sent to Kan-Ru Chen <koster@debian.org>. (Mon, 05 Mar 2012 03:57:09 GMT) Full text and rfc822 format available.

Message #15 received at 660324@bugs.debian.org (full text, mbox):

From: Hector Oron <zumbi@debian.org>
To: 660324@bugs.debian.org
Subject: picolisp: diff for NMU version 3.0.9.3-1.1
Date: Mon, 5 Mar 2012 04:55:58 +0100
[Message part 1 (text/plain, inline)]
tags 660324 + pending
thanks

Dear maintainer,

I've prepared an NMU for picolisp (versioned as 3.0.9.3-1.1) and
uploaded it to DELAYED/7. Please feel free to tell me if I
should delay it longer.

Regards.

-- 
  Hector Oron
[picolisp-3.0.9.3-1.1-nmu.diff (text/x-diff, attachment)]

Added tag(s) pending. Request was from Hector Oron <zumbi@debian.org> to control@bugs.debian.org. (Mon, 05 Mar 2012 03:57:10 GMT) Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org:
Bug#660324; Package picolisp. (Mon, 05 Mar 2012 14:33:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Kan-Ru Chen <koster@debian.org>:
Extra info received and forwarded to list. (Mon, 05 Mar 2012 14:33:03 GMT) Full text and rfc822 format available.

Message #22 received at 660324@bugs.debian.org (full text, mbox):

From: Kan-Ru Chen <koster@debian.org>
To: Hector Oron <zumbi@debian.org>
Cc: 660324@bugs.debian.org, peter green <plugwash@p10link.net>
Subject: Re: Bug#660324: picolisp FTBFS on armhf
Date: Mon, 05 Mar 2012 22:30:58 +0800
[Message part 1 (text/plain, inline)]
Hi!

Thanks for the patches, I am preparing to upload a new upstream release
so no NMU required :)

I broke the Makefile patch in last upload so the hardening flags
weren't actually applied and lead to FTBFS on armhf.

> As I see it there are two problems in the package:
>
> 1. Hardening rules are not properly passed to the build system, for that you
> might need to set CFLAGS and LDFLAGS as:
>   make -C src CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" OS=Linux CPU=$(DEB_HOST_ARCH_CPU) picolisp tools gate
>   make -C src64 CFLAGS="$(CFLAGS)" LDFLAGS="$(LDFLAGS)" OS=Linux
>
>   This way the build system takes the flags, but FTBFS, with full hardening set.

The flags are passed to the build system properly, but the Makefile
mistakenly overrides the CFLAGS. 

> 2. amd64 and armhf arches fail because the linkage is trying to link non-PIE object code.

On amd64 -fPIE is explicitly disabled because it's mostly written in
assembly and already handles PIC when needed. The codes aren't compiled
with gcc so enable -fPIE is meaningless.

> The following patch should fix the issue with -fPIE, but you are still not passing hardening flags to the build.
> I have not been able to test on armhf, but once I do, and if you dont have inconvenient I shall proceed with a NMU.

Thanks again, but once picolisp_build_on_multi_cpu.patch is fixed they
will build fine.

Cheers,
Kanru
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Kan-Ru Chen <koster@debian.org>:
Bug#660324; Package picolisp. (Mon, 05 Mar 2012 14:51:03 GMT) Full text and rfc822 format available.

Acknowledgement sent to Hector Oron <hector.oron@gmail.com>:
Extra info received and forwarded to list. Copy sent to Kan-Ru Chen <koster@debian.org>. (Mon, 05 Mar 2012 14:51:03 GMT) Full text and rfc822 format available.

Message #27 received at 660324@bugs.debian.org (full text, mbox):

From: Hector Oron <hector.oron@gmail.com>
To: Kan-Ru Chen <koster@debian.org>
Cc: 660324@bugs.debian.org, peter green <plugwash@p10link.net>
Subject: Re: Bug#660324: picolisp FTBFS on armhf
Date: Mon, 5 Mar 2012 15:47:58 +0100
Hello Kan-Ru,

2012/3/5 Kan-Ru Chen <koster@debian.org>:

> Thanks again, but once picolisp_build_on_multi_cpu.patch is fixed they
> will build fine.

Thanks. I have cancelled upload to delayed queue.
.
Cheers,
-- 
 Héctor Orón  -.. . -... .. .- -.   -.. . ...- . .-.. --- .--. . .-.




Reply sent to Kan-Ru Chen <koster@debian.org>:
You have taken responsibility. (Mon, 05 Mar 2012 15:30:23 GMT) Full text and rfc822 format available.

Notification sent to peter green <plugwash@p10link.net>:
Bug acknowledged by developer. (Mon, 05 Mar 2012 15:30:24 GMT) Full text and rfc822 format available.

Message #32 received at 660324-close@bugs.debian.org (full text, mbox):

From: Kan-Ru Chen <koster@debian.org>
To: 660324-close@bugs.debian.org
Subject: Bug#660324: fixed in picolisp 3.0.9.4-1
Date: Mon, 05 Mar 2012 15:29:08 +0000
Source: picolisp
Source-Version: 3.0.9.4-1

We believe that the bug you reported is fixed in the latest version of
picolisp, which is due to be installed in the Debian FTP archive:

picolisp_3.0.9.4-1.debian.tar.gz
  to main/p/picolisp/picolisp_3.0.9.4-1.debian.tar.gz
picolisp_3.0.9.4-1.dsc
  to main/p/picolisp/picolisp_3.0.9.4-1.dsc
picolisp_3.0.9.4-1_amd64.deb
  to main/p/picolisp/picolisp_3.0.9.4-1_amd64.deb
picolisp_3.0.9.4.orig.tar.gz
  to main/p/picolisp/picolisp_3.0.9.4.orig.tar.gz



A summary of the changes between this version and the previous one is
attached.

Thank you for reporting the bug, which will now be closed.  If you
have further comments please address them to 660324@bugs.debian.org,
and the maintainer will reopen the bug report if appropriate.

Debian distribution maintenance software
pp.
Kan-Ru Chen <koster@debian.org> (supplier of updated picolisp package)

(This message was generated automatically at their request; if you
believe that there is a problem with it please contact the archive
administrators by mailing ftpmaster@debian.org)


-----BEGIN PGP SIGNED MESSAGE-----
Hash: SHA256

Format: 1.8
Date: Mon, 05 Mar 2012 22:41:16 +0800
Source: picolisp
Binary: picolisp
Architecture: source amd64
Version: 3.0.9.4-1
Distribution: unstable
Urgency: low
Maintainer: Kan-Ru Chen <koster@debian.org>
Changed-By: Kan-Ru Chen <koster@debian.org>
Description: 
 picolisp   - Lisp interpreter and application server framework
Closes: 660324
Changes: 
 picolisp (3.0.9.4-1) unstable; urgency=low
 .
   * New upstream release.
   * Sync to upstream tip.
   * debian/patches/picolisp_build_on_multi_cpu.patch:
     - Correctly append CFLAGS to upstream CFLAGS. Fixes FTBFS on armhf.
       Thanks to Peter Green and Hector Oron (Closes: #660324).
   * debian/copyright:
     - Update copyright-format to 1.0.
   * debian/control:
     - Bump Standards-Version to 3.9.3.
Checksums-Sha1: 
 629ba47eac0a70519f717750f28604f411176327 2098 picolisp_3.0.9.4-1.dsc
 f40074140231d545d272abf38e421d2bfc756591 815458 picolisp_3.0.9.4.orig.tar.gz
 bc2f1d8f63553f1b42c80e7af14c6d218ee5bc47 9412 picolisp_3.0.9.4-1.debian.tar.gz
 8c9bcdd6e8a43c699df11fc60c90c53144f36d10 895284 picolisp_3.0.9.4-1_amd64.deb
Checksums-Sha256: 
 0aab85c22b0b58ffc047580d46b92c4de09755dd95f6baaf81b555003dd75adf 2098 picolisp_3.0.9.4-1.dsc
 ec6c181fd3ab28558de23596163b92346f2b1a44b4cca4506d5ee01b72477e57 815458 picolisp_3.0.9.4.orig.tar.gz
 08c77c2fbcd09110a06c730e06de9dcf864b550b7b019676c1e3d7af6ca0aea0 9412 picolisp_3.0.9.4-1.debian.tar.gz
 5c7434fd4c1ff750b27c78b2609ce3813958273fab719bf0de81613ed4e685a7 895284 picolisp_3.0.9.4-1_amd64.deb
Files: 
 67ce074af8319d05fadef5b329fc3731 2098 lisp optional picolisp_3.0.9.4-1.dsc
 0d076bd18f3e00260aa1d1a69078a8b9 815458 lisp optional picolisp_3.0.9.4.orig.tar.gz
 018b51bc05399904b019ad5b6b50b877 9412 lisp optional picolisp_3.0.9.4-1.debian.tar.gz
 7b75b44da9eb55db7c1c610071b4a0a7 895284 lisp optional picolisp_3.0.9.4-1_amd64.deb

-----BEGIN PGP SIGNATURE-----
Version: GnuPG v1.4.12 (GNU/Linux)

iQIcBAEBCAAGBQJPVNYxAAoJEAo5NUq25X3h13oP/0sLWjUy1vlGeayubnqRwIY+
bxNBfHzDQYuKsuQpDPTGg/gM2f9vLknmQ5zwk48Zcxy1QmRvd1XSjq9s3l5TymDE
ZC7GisHw77rEa76qnCXdvhVwKsDzDNMnUGfpTVNGXzAz/BW1iXou2IZ1JhPPvmaI
O0FjJs+2/i6rUQ8BVU6vjFbJr9id3MfL9jL4aVJwLpFWWdj0mku2zoUqccIpKHir
S+g52oyrdDVK4EzGnND7cy46B+McDeOXq+l02CEPO7kXapujZgClO6RPkzVNS5RA
M78AAqV7zGdfePx/i7OmJ2OBdaRDUdEDiZXqsIFUIey2OK6A4I9+DBTNzuRNY11O
LkG/cPYTkTOKV7ueM1clbiFXx/1hsQx/Op+um1Crjt0L98tkxKwYOwJpqD92FSUk
OgXPM5zjJ3L73SiHf9zWGmEpmsjHhUMCzza64utcVF35vFPsaP+fXB9JZO5Lw5uY
cLAmbYeCoRs+Af2+O4/+pqIk8mUGzSVr30sAZpT2DHMMSKAu5T13MqqEhDw4NI/C
KT2VtT/+LCP5oD0ucBslEWw4tNZl1uSzEWuYmSXjTOb+QNs7Mv2k3H8o2o/gFImR
swAkN6oSZqMSr9r+f4gG65D4DqqPJVozUnOqj1QJtJgjOoa+CJTT9IY/TwYV2w9W
MQ2BASP750fZyLj+9KjE
=tYhc
-----END PGP SIGNATURE-----





Bug archived. Request was from Debbugs Internal Request <owner@bugs.debian.org> to internal_control@bugs.debian.org. (Fri, 13 Apr 2012 07:38:43 GMT) Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Wed Apr 16 19:43:17 2014; Machine Name: buxtehude.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.